---
title: llarp::ILinkLayer

---

# llarp::ILinkLayer





Inherited by [llarp::iwp::LinkLayer](Classes/structllarp_1_1iwp_1_1LinkLayer.md)

## Protected Types

|                | Name           |
| -------------- | -------------- |
| using [util::NullLock](Classes/structllarp_1_1util_1_1NullLock.md) | **[Lock_t](Classes/structllarp_1_1ILinkLayer.md#using-lock-t)**  |
| using [util::NullMutex](Classes/structllarp_1_1util_1_1NullMutex.md) | **[Mutex_t](Classes/structllarp_1_1ILinkLayer.md#using-mutex-t)**  |
| using std::unordered_multimap< [RouterID](Classes/structllarp_1_1RouterID.md), std::shared_ptr< [ILinkSession](Classes/structllarp_1_1ILinkSession.md) > > | **[AuthedLinks](Classes/structllarp_1_1ILinkLayer.md#using-authedlinks)**  |
| using std::unordered_map< [SockAddr](Classes/structllarp_1_1SockAddr.md), std::shared_ptr< [ILinkSession](Classes/structllarp_1_1ILinkSession.md) > > | **[Pending](Classes/structllarp_1_1ILinkLayer.md#using-pending)**  |

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[ILinkLayer](Classes/structllarp_1_1ILinkLayer.md#function-ilinklayer)**(std::shared_ptr< [KeyManager](Classes/structllarp_1_1KeyManager.md) > keyManager, [GetRCFunc](Namespaces/namespacellarp.md#using-getrcfunc) getrc, [LinkMessageHandler](Namespaces/namespacellarp.md#using-linkmessagehandler) handler, [SignBufferFunc](Namespaces/namespacellarp.md#using-signbufferfunc) signFunc, [BeforeConnectFunc_t](Namespaces/namespacellarp.md#using-beforeconnectfunc-t) before, [SessionEstablishedHandler](Namespaces/namespacellarp.md#using-sessionestablishedhandler) sessionEstablish, [SessionRenegotiateHandler](Namespaces/namespacellarp.md#using-sessionrenegotiatehandler) renegotiate, [TimeoutHandler](Namespaces/namespacellarp.md#using-timeouthandler) timeout, [SessionClosedHandler](Namespaces/namespacellarp.md#using-sessionclosedhandler) closed, [PumpDoneHandler](Namespaces/namespacellarp.md#using-pumpdonehandler) pumpDone, [WorkerFunc_t](Namespaces/namespacellarp.md#using-workerfunc-t) doWork) |
| virtual | **[~ILinkLayer](Classes/structllarp_1_1ILinkLayer.md#function-~ilinklayer)**() =default |
| llarp_time_t | **[Now](Classes/structllarp_1_1ILinkLayer.md#function-now)**() const<br>get current time via event loop  |
| bool | **[HasSessionTo](Classes/structllarp_1_1ILinkLayer.md#function-hassessionto)**(const [RouterID](Classes/structllarp_1_1RouterID.md) & pk) |
| void | **[ForEachSession](Classes/structllarp_1_1ILinkLayer.md#function-foreachsession)**(std::function< void(const [ILinkSession](Classes/structllarp_1_1ILinkSession.md) *)> visit, bool randomize =false) const |
| void | **[ForEachSession](Classes/structllarp_1_1ILinkLayer.md#function-foreachsession)**(std::function< void([ILinkSession](Classes/structllarp_1_1ILinkSession.md) *)> visit) |
| void | **[UnmapAddr](Classes/structllarp_1_1ILinkLayer.md#function-unmapaddr)**(const [SockAddr](Classes/structllarp_1_1SockAddr.md) & addr) |
| void | **[SendTo_LL](Classes/structllarp_1_1ILinkLayer.md#function-sendto-ll)**(const [SockAddr](Classes/structllarp_1_1SockAddr.md) & to, const [llarp_buffer_t](Classes/structllarp__buffer__t.md) & pkt) |
| void | **[Bind](Classes/structllarp_1_1ILinkLayer.md#function-bind)**([AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) * router, [SockAddr](Classes/structllarp_1_1SockAddr.md) addr) |
| virtual std::shared_ptr< [ILinkSession](Classes/structllarp_1_1ILinkSession.md) > | **[NewOutboundSession](Classes/structllarp_1_1ILinkLayer.md#function-newoutboundsession)**(const [RouterContact](Classes/structllarp_1_1RouterContact.md) & rc, const [AddressInfo](Classes/structllarp_1_1AddressInfo.md) & ai) =0 |
| std::shared_ptr< [ILinkSession](Classes/structllarp_1_1ILinkSession.md) > | **[FindSessionByPubkey](Classes/structllarp_1_1ILinkLayer.md#function-findsessionbypubkey)**([RouterID](Classes/structllarp_1_1RouterID.md) pk)<br>fetch a session by the identity pubkey it claims  |
| virtual void | **[Pump](Classes/structllarp_1_1ILinkLayer.md#function-pump)**() |
| virtual void | **[RecvFrom](Classes/structllarp_1_1ILinkLayer.md#function-recvfrom)**(const [SockAddr](Classes/structllarp_1_1SockAddr.md) & from, ILinkSession::Packet_t pkt) =0 |
| bool | **[PickAddress](Classes/structllarp_1_1ILinkLayer.md#function-pickaddress)**(const [RouterContact](Classes/structllarp_1_1RouterContact.md) & rc, [AddressInfo](Classes/structllarp_1_1AddressInfo.md) & picked) const |
| bool | **[TryEstablishTo](Classes/structllarp_1_1ILinkLayer.md#function-tryestablishto)**([RouterContact](Classes/structllarp_1_1RouterContact.md) rc) |
| bool | **[Start](Classes/structllarp_1_1ILinkLayer.md#function-start)**() |
| virtual void | **[Stop](Classes/structllarp_1_1ILinkLayer.md#function-stop)**() |
| virtual std::string_view | **[Name](Classes/structllarp_1_1ILinkLayer.md#function-name)**() const =0 |
| util::StatusObject | **[ExtractStatus](Classes/structllarp_1_1ILinkLayer.md#function-extractstatus)**() const |
| void | **[CloseSessionTo](Classes/structllarp_1_1ILinkLayer.md#function-closesessionto)**(const [RouterID](Classes/structllarp_1_1RouterID.md) & remote) |
| void | **[KeepAliveSessionTo](Classes/structllarp_1_1ILinkLayer.md#function-keepalivesessionto)**(const [RouterID](Classes/structllarp_1_1RouterID.md) & remote) |
| virtual bool | **[SendTo](Classes/structllarp_1_1ILinkLayer.md#function-sendto)**(const [RouterID](Classes/structllarp_1_1RouterID.md) & remote, const [llarp_buffer_t](Classes/structllarp__buffer__t.md) & buf, [ILinkSession::CompletionHandler](Classes/structllarp_1_1ILinkSession.md#using-completionhandler) completed, uint16_t priority) |
| virtual bool | **[GetOurAddressInfo](Classes/structllarp_1_1ILinkLayer.md#function-getouraddressinfo)**([AddressInfo](Classes/structllarp_1_1AddressInfo.md) & addr) const |
| bool | **[VisitSessionByPubkey](Classes/structllarp_1_1ILinkLayer.md#function-visitsessionbypubkey)**(const [RouterID](Classes/structllarp_1_1RouterID.md) & pk, std::function< bool([ILinkSession](Classes/structllarp_1_1ILinkSession.md) *)> visit) |
| virtual uint16_t | **[Rank](Classes/structllarp_1_1ILinkLayer.md#function-rank)**() const =0 |
| const byte_t * | **[TransportPubKey](Classes/structllarp_1_1ILinkLayer.md#function-transportpubkey)**() const |
| const [SecretKey](Classes/structllarp_1_1SecretKey.md) & | **[RouterEncryptionSecret](Classes/structllarp_1_1ILinkLayer.md#function-routerencryptionsecret)**() const |
| const [SecretKey](Classes/structllarp_1_1SecretKey.md) & | **[TransportSecretKey](Classes/structllarp_1_1ILinkLayer.md#function-transportsecretkey)**() const |
| bool | **[IsCompatable](Classes/structllarp_1_1ILinkLayer.md#function-iscompatable)**(const [llarp::RouterContact](Classes/structllarp_1_1RouterContact.md) & other) const |
| bool | **[MapAddr](Classes/structllarp_1_1ILinkLayer.md#function-mapaddr)**(const [RouterID](Classes/structllarp_1_1RouterID.md) & pk, [ILinkSession](Classes/structllarp_1_1ILinkSession.md) * s) |
| void | **[Tick](Classes/structllarp_1_1ILinkLayer.md#function-tick)**(llarp_time_t now) |
| bool | **[operator<](Classes/structllarp_1_1ILinkLayer.md#function-operator<)**(const [ILinkLayer](Classes/structllarp_1_1ILinkLayer.md) & other) const |
| size_t | **[NumberOfPendingSessions](Classes/structllarp_1_1ILinkLayer.md#function-numberofpendingsessions)**() const<br>called by link session to remove a pending session who is timed out  |
| std::optional< int > | **[GetUDPFD](Classes/structllarp_1_1ILinkLayer.md#function-getudpfd)**() const |
| [AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) * | **[Router](Classes/structllarp_1_1ILinkLayer.md#function-router)**() const |
| const [SockAddr](Classes/structllarp_1_1SockAddr.md) & | **[LocalSocketAddr](Classes/structllarp_1_1ILinkLayer.md#function-localsocketaddr)**() const<br>Get the local sock addr we are bound on.  |

## Protected Functions

|                | Name           |
| -------------- | -------------- |
| bool | **[PutSession](Classes/structllarp_1_1ILinkLayer.md#function-putsession)**(const std::shared_ptr< [ILinkSession](Classes/structllarp_1_1ILinkSession.md) > & s) |
| | **[DECLARE_LOCK](Classes/structllarp_1_1ILinkLayer.md#function-declare-lock)**([Mutex_t](Classes/structllarp_1_1util_1_1NullMutex.md) , m_AuthedLinksMutex , ACQUIRED_BEFORE(m_PendingMutex) ) |
| AuthedLinks m_AuthedLinks | **[GUARDED_BY](Classes/structllarp_1_1ILinkLayer.md#function-guarded-by)**(m_AuthedLinksMutex ) |
| | **[DECLARE_LOCK](Classes/structllarp_1_1ILinkLayer.md#function-declare-lock)**([Mutex_t](Classes/structllarp_1_1util_1_1NullMutex.md) , m_PendingMutex , ACQUIRED_AFTER(m_AuthedLinksMutex) ) |
| Pending m_Pending | **[GUARDED_BY](Classes/structllarp_1_1ILinkLayer.md#function-guarded-by)**(m_PendingMutex ) |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| [LinkMessageHandler](Namespaces/namespacellarp.md#using-linkmessagehandler) | **[HandleMessage](Classes/structllarp_1_1ILinkLayer.md#variable-handlemessage)**  |
| [TimeoutHandler](Namespaces/namespacellarp.md#using-timeouthandler) | **[HandleTimeout](Classes/structllarp_1_1ILinkLayer.md#variable-handletimeout)**  |
| [SignBufferFunc](Namespaces/namespacellarp.md#using-signbufferfunc) | **[Sign](Classes/structllarp_1_1ILinkLayer.md#variable-sign)**  |
| [GetRCFunc](Namespaces/namespacellarp.md#using-getrcfunc) | **[GetOurRC](Classes/structllarp_1_1ILinkLayer.md#variable-getourrc)**  |
| [BeforeConnectFunc_t](Namespaces/namespacellarp.md#using-beforeconnectfunc-t) | **[BeforeConnect](Classes/structllarp_1_1ILinkLayer.md#variable-beforeconnect)**  |
| [SessionEstablishedHandler](Namespaces/namespacellarp.md#using-sessionestablishedhandler) | **[SessionEstablished](Classes/structllarp_1_1ILinkLayer.md#variable-sessionestablished)**  |
| [SessionClosedHandler](Namespaces/namespacellarp.md#using-sessionclosedhandler) | **[SessionClosed](Classes/structllarp_1_1ILinkLayer.md#variable-sessionclosed)**  |
| [SessionRenegotiateHandler](Namespaces/namespacellarp.md#using-sessionrenegotiatehandler) | **[SessionRenegotiate](Classes/structllarp_1_1ILinkLayer.md#variable-sessionrenegotiate)**  |
| [PumpDoneHandler](Namespaces/namespacellarp.md#using-pumpdonehandler) | **[PumpDone](Classes/structllarp_1_1ILinkLayer.md#variable-pumpdone)**  |
| std::shared_ptr< [KeyManager](Classes/structllarp_1_1KeyManager.md) > | **[keyManager](Classes/structllarp_1_1ILinkLayer.md#variable-keymanager)**  |
| [WorkerFunc_t](Namespaces/namespacellarp.md#using-workerfunc-t) | **[QueueWork](Classes/structllarp_1_1ILinkLayer.md#variable-queuework)**  |

## Protected Attributes

|                | Name           |
| -------------- | -------------- |
| [AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) * | **[m_Router](Classes/structllarp_1_1ILinkLayer.md#variable-m-router)**  |
| [SockAddr](Classes/structllarp_1_1SockAddr.md) | **[m_ourAddr](Classes/structllarp_1_1ILinkLayer.md#variable-m-ouraddr)**  |
| std::shared_ptr< [llarp::UDPHandle](Classes/structllarp_1_1UDPHandle.md) > | **[m_udp](Classes/structllarp_1_1ILinkLayer.md#variable-m-udp)**  |
| [SecretKey](Classes/structllarp_1_1SecretKey.md) | **[m_SecretKey](Classes/structllarp_1_1ILinkLayer.md#variable-m-secretkey)**  |
| std::unordered_map< [SockAddr](Classes/structllarp_1_1SockAddr.md), [RouterID](Classes/structllarp_1_1RouterID.md) > | **[m_AuthedAddrs](Classes/structllarp_1_1ILinkLayer.md#variable-m-authedaddrs)**  |
| std::unordered_map< [SockAddr](Classes/structllarp_1_1SockAddr.md), llarp_time_t > | **[m_RecentlyClosed](Classes/structllarp_1_1ILinkLayer.md#variable-m-recentlyclosed)**  |

## Protected Types Documentation

### using Lock_t

```cpp
using llarp::ILinkLayer::Lock_t =  util::NullLock;
```


### using Mutex_t

```cpp
using llarp::ILinkLayer::Mutex_t =  util::NullMutex;
```


### using AuthedLinks

```cpp
using llarp::ILinkLayer::AuthedLinks =  std::unordered_multimap<RouterID, std::shared_ptr<ILinkSession> >;
```


### using Pending

```cpp
using llarp::ILinkLayer::Pending =  std::unordered_map<SockAddr, std::shared_ptr<ILinkSession> >;
```


## Public Functions Documentation

### function ILinkLayer

```cpp
ILinkLayer(
    std::shared_ptr< KeyManager > keyManager,
    GetRCFunc getrc,
    LinkMessageHandler handler,
    SignBufferFunc signFunc,
    BeforeConnectFunc_t before,
    SessionEstablishedHandler sessionEstablish,
    SessionRenegotiateHandler renegotiate,
    TimeoutHandler timeout,
    SessionClosedHandler closed,
    PumpDoneHandler pumpDone,
    WorkerFunc_t doWork
)
```


### function ~ILinkLayer

```cpp
virtual ~ILinkLayer() =default
```


### function Now

```cpp
llarp_time_t Now() const
```

get current time via event loop 

### function HasSessionTo

```cpp
bool HasSessionTo(
    const RouterID & pk
)
```


### function ForEachSession

```cpp
void ForEachSession(
    std::function< void(const ILinkSession *)> visit,
    bool randomize =false
) const
```


### function ForEachSession

```cpp
void ForEachSession(
    std::function< void(ILinkSession *)> visit
)
```


### function UnmapAddr

```cpp
void UnmapAddr(
    const SockAddr & addr
)
```


### function SendTo_LL

```cpp
void SendTo_LL(
    const SockAddr & to,
    const llarp_buffer_t & pkt
)
```


### function Bind

```cpp
void Bind(
    AbstractRouter * router,
    SockAddr addr
)
```


### function NewOutboundSession

```cpp
virtual std::shared_ptr< ILinkSession > NewOutboundSession(
    const RouterContact & rc,
    const AddressInfo & ai
) =0
```


**Reimplemented by**: [llarp::iwp::LinkLayer::NewOutboundSession](Classes/structllarp_1_1iwp_1_1LinkLayer.md#function-newoutboundsession)


### function FindSessionByPubkey

```cpp
std::shared_ptr< ILinkSession > FindSessionByPubkey(
    RouterID pk
)
```

fetch a session by the identity pubkey it claims 

### function Pump

```cpp
virtual void Pump()
```


### function RecvFrom

```cpp
virtual void RecvFrom(
    const SockAddr & from,
    ILinkSession::Packet_t pkt
) =0
```


**Reimplemented by**: [llarp::iwp::LinkLayer::RecvFrom](Classes/structllarp_1_1iwp_1_1LinkLayer.md#function-recvfrom)


### function PickAddress

```cpp
bool PickAddress(
    const RouterContact & rc,
    AddressInfo & picked
) const
```


### function TryEstablishTo

```cpp
bool TryEstablishTo(
    RouterContact rc
)
```


### function Start

```cpp
bool Start()
```


### function Stop

```cpp
virtual void Stop()
```


### function Name

```cpp
virtual std::string_view Name() const =0
```


**Reimplemented by**: [llarp::iwp::LinkLayer::Name](Classes/structllarp_1_1iwp_1_1LinkLayer.md#function-name)


### function ExtractStatus

```cpp
util::StatusObject ExtractStatus() const
```


### function CloseSessionTo

```cpp
void CloseSessionTo(
    const RouterID & remote
)
```


### function KeepAliveSessionTo

```cpp
void KeepAliveSessionTo(
    const RouterID & remote
)
```


### function SendTo

```cpp
virtual bool SendTo(
    const RouterID & remote,
    const llarp_buffer_t & buf,
    ILinkSession::CompletionHandler completed,
    uint16_t priority
)
```


### function GetOurAddressInfo

```cpp
virtual bool GetOurAddressInfo(
    AddressInfo & addr
) const
```


### function VisitSessionByPubkey

```cpp
bool VisitSessionByPubkey(
    const RouterID & pk,
    std::function< bool(ILinkSession *)> visit
)
```


### function Rank

```cpp
virtual uint16_t Rank() const =0
```


**Reimplemented by**: [llarp::iwp::LinkLayer::Rank](Classes/structllarp_1_1iwp_1_1LinkLayer.md#function-rank)


### function TransportPubKey

```cpp
const byte_t * TransportPubKey() const
```


### function RouterEncryptionSecret

```cpp
inline const SecretKey & RouterEncryptionSecret() const
```


### function TransportSecretKey

```cpp
const SecretKey & TransportSecretKey() const
```


### function IsCompatable

```cpp
inline bool IsCompatable(
    const llarp::RouterContact & other
) const
```


### function MapAddr

```cpp
bool MapAddr(
    const RouterID & pk,
    ILinkSession * s
)
```


### function Tick

```cpp
void Tick(
    llarp_time_t now
)
```


### function operator<

```cpp
inline bool operator<(
    const ILinkLayer & other
) const
```


### function NumberOfPendingSessions

```cpp
inline size_t NumberOfPendingSessions() const
```

called by link session to remove a pending session who is timed out 

count the number of sessions that are yet to be fully connected 


### function GetUDPFD

```cpp
std::optional< int > GetUDPFD() const
```


### function Router

```cpp
inline AbstractRouter * Router() const
```


### function LocalSocketAddr

```cpp
inline const SockAddr & LocalSocketAddr() const
```

Get the local sock addr we are bound on. 

## Protected Functions Documentation

### function PutSession

```cpp
bool PutSession(
    const std::shared_ptr< ILinkSession > & s
)
```


### function DECLARE_LOCK

```cpp
DECLARE_LOCK(
    Mutex_t ,
    m_AuthedLinksMutex ,
    ACQUIRED_BEFORE(m_PendingMutex) 
)
```


### function GUARDED_BY

```cpp
AuthedLinks m_AuthedLinks GUARDED_BY(
    m_AuthedLinksMutex 
)
```


### function DECLARE_LOCK

```cpp
DECLARE_LOCK(
    Mutex_t ,
    m_PendingMutex ,
    ACQUIRED_AFTER(m_AuthedLinksMutex) 
)
```


### function GUARDED_BY

```cpp
Pending m_Pending GUARDED_BY(
    m_PendingMutex 
)
```


## Public Attributes Documentation

### variable HandleMessage

```cpp
LinkMessageHandler HandleMessage;
```


### variable HandleTimeout

```cpp
TimeoutHandler HandleTimeout;
```


### variable Sign

```cpp
SignBufferFunc Sign;
```


### variable GetOurRC

```cpp
GetRCFunc GetOurRC;
```


### variable BeforeConnect

```cpp
BeforeConnectFunc_t BeforeConnect;
```


### variable SessionEstablished

```cpp
SessionEstablishedHandler SessionEstablished;
```


### variable SessionClosed

```cpp
SessionClosedHandler SessionClosed;
```


### variable SessionRenegotiate

```cpp
SessionRenegotiateHandler SessionRenegotiate;
```


### variable PumpDone

```cpp
PumpDoneHandler PumpDone;
```


### variable keyManager

```cpp
std::shared_ptr< KeyManager > keyManager;
```


### variable QueueWork

```cpp
WorkerFunc_t QueueWork;
```


## Protected Attributes Documentation

### variable m_Router

```cpp
AbstractRouter * m_Router;
```


### variable m_ourAddr

```cpp
SockAddr m_ourAddr;
```


### variable m_udp

```cpp
std::shared_ptr< llarp::UDPHandle > m_udp;
```


### variable m_SecretKey

```cpp
SecretKey m_SecretKey;
```


### variable m_AuthedAddrs

```cpp
std::unordered_map< SockAddr, RouterID > m_AuthedAddrs;
```


### variable m_RecentlyClosed

```cpp
std::unordered_map< SockAddr, llarp_time_t > m_RecentlyClosed;
```


-------------------------------

Updated on 2023-01-13 at 22:44:38 +0000