---
title: llarp::service::EndpointState

---

# llarp::service::EndpointState





## Public Functions

|                | Name           |
| -------------- | -------------- |
| bool | **[Configure](Classes/structllarp_1_1service_1_1EndpointState.md#function-configure)**(const [NetworkConfig](Classes/structllarp_1_1NetworkConfig.md) & conf) |
| util::StatusObject | **[ExtractStatus](Classes/structllarp_1_1service_1_1EndpointState.md#function-extractstatus)**(util::StatusObject & obj) const |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| std::set< [RouterID](Classes/structllarp_1_1RouterID.md) > | **[m_SnodeBlacklist](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-snodeblacklist)**  |
| [AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) * | **[m_Router](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-router)**  |
| std::string | **[m_Keyfile](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-keyfile)**  |
| std::string | **[m_Name](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-name)**  |
| std::string | **[m_NetNS](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-netns)**  |
| bool | **[m_ExitEnabled](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-exitenabled)**  |
| PendingTraffic | **[m_PendingTraffic](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-pendingtraffic)**  |
| Sessions | **[m_RemoteSessions](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-remotesessions)**  |
| Sessions | **[m_DeadSessions](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-deadsessions)**  |
| std::set< [ConvoTag](Classes/structllarp_1_1service_1_1ConvoTag.md) > | **[m_InboundConvos](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-inboundconvos)**  |
| SNodeSessions | **[m_SNodeSessions](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-snodesessions)**  |
| std::unordered_multimap< [Address](Classes/structllarp_1_1service_1_1Address.md), PathEnsureHook > | **[m_PendingServiceLookups](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-pendingservicelookups)**  |
| std::unordered_map< [Address](Classes/structllarp_1_1service_1_1Address.md), llarp_time_t > | **[m_LastServiceLookupTimes](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-lastservicelookuptimes)**  |
| std::unordered_map< [RouterID](Classes/structllarp_1_1RouterID.md), uint32_t > | **[m_ServiceLookupFails](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-servicelookupfails)**  |
| PendingRouters | **[m_PendingRouters](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-pendingrouters)**  |
| llarp_time_t | **[m_LastPublish](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-lastpublish)**  |
| llarp_time_t | **[m_LastPublishAttempt](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-lastpublishattempt)**  |
| [IntroSet](Classes/structllarp_1_1service_1_1IntroSet.md) | **[m_IntroSet](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-introset)** <br>our introset  |
| PendingLookups | **[m_PendingLookups](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-pendinglookups)** <br>pending remote service lookups by id  |
| std::list< std::function< bool(void)> > | **[m_OnInit](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-oninit)** <br>on initialize functions  |
| ConvoMap | **[m_Sessions](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-sessions)** <br>conversations  |
| OutboundSessions_t | **[m_OutboundSessions](Classes/structllarp_1_1service_1_1EndpointState.md#variable-m-outboundsessions)**  |
| [util::DecayingHashTable](Classes/structllarp_1_1util_1_1DecayingHashTable.md)< std::string, std::variant< [Address](Classes/structllarp_1_1service_1_1Address.md), [RouterID](Classes/structllarp_1_1RouterID.md) >, std::hash< std::string > > | **[nameCache](Classes/structllarp_1_1service_1_1EndpointState.md#variable-namecache)**  |
| [LNSLookupTracker](Classes/classllarp_1_1service_1_1LNSLookupTracker.md) | **[lnsTracker](Classes/structllarp_1_1service_1_1EndpointState.md#variable-lnstracker)**  |

## Public Functions Documentation

### function Configure

```cpp
bool Configure(
    const NetworkConfig & conf
)
```


### function ExtractStatus

```cpp
util::StatusObject ExtractStatus(
    util::StatusObject & obj
) const
```


## Public Attributes Documentation

### variable m_SnodeBlacklist

```cpp
std::set< RouterID > m_SnodeBlacklist;
```


### variable m_Router

```cpp
AbstractRouter * m_Router;
```


### variable m_Keyfile

```cpp
std::string m_Keyfile;
```


### variable m_Name

```cpp
std::string m_Name;
```


### variable m_NetNS

```cpp
std::string m_NetNS;
```


### variable m_ExitEnabled

```cpp
bool m_ExitEnabled = false;
```


### variable m_PendingTraffic

```cpp
PendingTraffic m_PendingTraffic;
```


### variable m_RemoteSessions

```cpp
Sessions m_RemoteSessions;
```


### variable m_DeadSessions

```cpp
Sessions m_DeadSessions;
```


### variable m_InboundConvos

```cpp
std::set< ConvoTag > m_InboundConvos;
```


### variable m_SNodeSessions

```cpp
SNodeSessions m_SNodeSessions;
```


### variable m_PendingServiceLookups

```cpp
std::unordered_multimap< Address, PathEnsureHook > m_PendingServiceLookups;
```


### variable m_LastServiceLookupTimes

```cpp
std::unordered_map< Address, llarp_time_t > m_LastServiceLookupTimes;
```


### variable m_ServiceLookupFails

```cpp
std::unordered_map< RouterID, uint32_t > m_ServiceLookupFails;
```


### variable m_PendingRouters

```cpp
PendingRouters m_PendingRouters;
```


### variable m_LastPublish

```cpp
llarp_time_t m_LastPublish = 0s;
```


### variable m_LastPublishAttempt

```cpp
llarp_time_t m_LastPublishAttempt = 0s;
```


### variable m_IntroSet

```cpp
IntroSet m_IntroSet;
```

our introset 

### variable m_PendingLookups

```cpp
PendingLookups m_PendingLookups;
```

pending remote service lookups by id 

### variable m_OnInit

```cpp
std::list< std::function< bool(void)> > m_OnInit;
```

on initialize functions 

### variable m_Sessions

```cpp
ConvoMap m_Sessions;
```

conversations 

### variable m_OutboundSessions

```cpp
OutboundSessions_t m_OutboundSessions;
```


### variable nameCache

```cpp
util::DecayingHashTable< std::string, std::variant< Address, RouterID >, std::hash< std::string > > nameCache;
```


### variable lnsTracker

```cpp
LNSLookupTracker lnsTracker;
```


-------------------------------

Updated on 2023-01-13 at 22:44:39 +0000