---
title: llarp/net/interface_info.hpp

---

# llarp/net/interface_info.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::net](Namespaces/namespacellarp_1_1net.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::net::InterfaceInfo](Classes/structllarp_1_1net_1_1InterfaceInfo.md)** <br>info about a network interface lokinet does not own  |




## Source code

```cpp
#pragma once

#include <optional>
#include <string>
#include <vector>
#include <llarp/util/formattable.hpp>
#include "ip_range.hpp"

namespace llarp::net
{
  struct InterfaceInfo
  {
    std::string name;
    int index;
    std::vector<IPRange> addrs;
    std::optional<ipaddr_t> gateway;

    std::string
    ToString() const;
  };
}  // namespace llarp::net

template <>
inline constexpr bool llarp::IsToStringFormattable<llarp::net::InterfaceInfo> = true;
```


-------------------------------

Updated on 2023-01-13 at 22:44:39 +0000
