---
title: llarp/dns/nm_platform.hpp

---

# llarp/dns/nm_platform.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::dns](Namespaces/namespacellarp_1_1dns.md)**  |
| **[llarp::dns::nm](Namespaces/namespacellarp_1_1dns_1_1nm.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::dns::nm::Platform](Classes/classllarp_1_1dns_1_1nm_1_1Platform.md)**  |




## Source code

```cpp
#pragma once
#include "platform.hpp"

#include <llarp/constants/platform.hpp>
#include <type_traits>
#include <unordered_map>

namespace llarp::dns
{
  namespace nm
  {
    // a dns platform that sets dns via network manager
    class Platform : public I_Platform
    {
     public:
      virtual ~Platform() = default;

      void
      set_resolver(unsigned int index, llarp::SockAddr dns, bool global) override;
    };
  };  // namespace nm
  using NM_Platform_t = std::conditional_t<false, nm::Platform, Null_Platform>;
}  // namespace llarp::dns
```


-------------------------------

Updated on 2023-01-13 at 22:44:39 +0000
