---
title: llarp/util/types.hpp

---

# llarp/util/types.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[oxen::log::literals](Namespaces/namespaceoxen_1_1log_1_1literals.md)**  |

## Types

|                | Name           |
| -------------- | -------------- |
| using uint8_t | **[byte_t](Files/util_2types_8hpp.md#using-byte-t)**  |
| using std::uint8_t | **[llarp_proto_version_t](Files/util_2types_8hpp.md#using-llarp-proto-version-t)**  |
| using llarp::Duration_t | **[llarp_time_t](Files/util_2types_8hpp.md#using-llarp-time-t)**  |

## Types Documentation

### using byte_t

```cpp
using byte_t =  uint8_t;
```


### using llarp_proto_version_t

```cpp
using llarp_proto_version_t =  std::uint8_t;
```


### using llarp_time_t

```cpp
using llarp_time_t =  llarp::Duration_t;
```





## Source code

```cpp
#pragma once
#include <cstdint>
#include <string>
#include <chrono>

#include "oxen/log/format.hpp"

using byte_t = uint8_t;
using llarp_proto_version_t = std::uint8_t;

namespace llarp
{
  using Duration_t = std::chrono::milliseconds;
  using namespace std::literals;
  using namespace oxen::log::literals;

  uint64_t
  ToMS(Duration_t duration);

  using DateClock_t = std::chrono::system_clock;
  using TimePoint_t = DateClock_t::time_point;
}  // namespace llarp

using llarp_time_t = llarp::Duration_t;
```


-------------------------------

Updated on 2023-01-13 at 22:44:39 +0000
